#!/usr/bin/perl
# Turns Google Search History into an RSS Feed
#  By John Resig
#  jeresig@gmail.com
#  http://ejohn.org/

use WWW::Mechanize;
use XML::LibXML;
use XML::RSS;

# Change these to point to your account information
my $email = '';
my $pass = '';

my $base = "/html/body/table[4]/tr[2]/td[2]/table/tr/td/table/tr";

my $m = new WWW::Mechanize( cookie_jar => {} );

$m->agent_alias( 'Windows IE 6' );

$m->get( "https://www.google.com/accounts/ServiceLoginBox" );

$m->submit_form(
    form_number => 1,
    fields => {
        Email => $email,
        Passwd => $pass
    }
);

$m->follow_link( text_regex => qr/click here/i );
$m->get( "http://www.google.com/searchhistory/" );

my $p = new XML::LibXML();
$p->recover(1);
$p->validation(0);
$p->expand_entities(0);
$p->keep_blanks(0);

open(OLDERR, ">&STDERR");
open(STDERR, ">/dev/null");
my $doc = $p->parse_html_string($m->content());
close(STDERR);
open(STDERR,">&OLDERR");

my $rss = new XML::RSS( version => '2.0' );

$rss->channel(
    title => "Recent Searches for " . $email,
    link => "http://google.com/searchhistory/"
);
    
my $curTerm = "";

for my $tr ( $doc->findnodes($base) ) {
    if ( my @link = $tr->findnodes("td[2]/font/a") ) {
        $rss->add_item(
            title => $link[0]->textContent,
            link => $link[0]->getAttribute( "href" ),
            description => qq~Found when searching for 
                <a href="http://google.com/search?q=$curTerm">$curTerm</a>.~
        );
    } elsif ( my @link = $tr->findnodes("td[1]/font/a/b") ) {
        $curTerm = $link[0]->textContent;
    }
}

print $rss->as_string;
